<%@ page
	pageEncoding="UTF-8"
	session="false"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<base:page type="popup">
	<base:head styles="table.css">
		<link rel="stylesheet" type="text/css" href="css/print.css">
		<script>
		function init()
		{
			window.opener.Print.finalizeTablePrint(window);
		}
		function orientationOnChange()
		{
			var landscape = document.getElementById('orientation-landscape').checked;
			var paper = document.getElementById('paper');
			Main.addOrRemoveClass(paper, 'landscape', landscape);
		}
		</script>
		<style>
		/* Things that should be hidden in the print version
			* 'panelgroup' include the button and navigation toolbars
			* icons inside table cells are usually 'add-new-item' links
			* The 'dropdown' is eye-candy for the enumerated filter options
		*/
		.panelgroup, td.cell .icon.link, .dropdown
		{
			display: none;
		}
		
		/* Change background color to white */
		tr
		{
			background-color: #FFFFFF !important;
		}
		
		/* Add some top padding to the first table header row */
		thead tr:first-child th
		{
			padding-top: 0.5em !important;
		}
		
		/* Add bottom padding to the last table header row */
		thead tr:last-child th
		{
			border-bottom: 2px solid #A0A0A0 !important;
			padding-bottom: 0.5em !important;
		}

		/* Add an icon to the filter row */
		thead tr:last-child th:first-child:before
		{
			content: url('images/filter.png');
		}

		/* Hide the filter row if there is no filter */
		.nofilterrow thead tr:last-child
		{
			display: none;
		}
		
		/* Remove borders around filter input fields */
		th.propertyfilter input, select, th.propertyfilter .multiselect
		{
			border: 0 !important;
		}
		
		/* Hide the column with checkboxes first in each row 
			Can't use display: none since that will cause misalignment between columns.
		*/
		th.check
		{
			width: 0 !important;
			max-width: 0 !important;
			min-width: 0 !important;
		}
		
		/* All links should be like ordinary text */
		.link, a, label
		{
			color: #000000 !important;
		}
		</style>
	</base:head>
	
	<base:body onload="init()">
		<div id="print-control" class="noprint">
			<table>
			<tr>
				<td id="print-button" onclick="window.print()"><img src="images/print.png">Print&hellip;</td>
				<td id="print-orientation"><label><input type="checkbox" onchange="orientationOnChange()" id="orientation-landscape">Landscape</label></td>
				<td id="print-note"></td>
			</tr>
			</table>
		</div>
	
		<div class="paper" id="paper" onclick="return false;">
			<div id="print-title">Print title</div>
			<div id="print-area"></div>
		</div>
	</base:body>
</base:page>
