<%@ page 
	pageEncoding="UTF-8"
	session="false"
	contentType="text/javascript"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%!
	final String homeUrl = ExtensionsControl.getHomeUrl("net.sf.basedb.print.print-table");
%>

var Print = function()
{
	var HOME_URL = '<%=homeUrl%>/';

	var print = {};
	var internal = {};
	
	/*
		Open a popup window giving a print preview of an item-listing table.
		Several adjustments are made to the visual appearance of the table to
		make it more suitable for printing.
	*/
	print.tablePrint = function()
	{
		
		var printData = {};
		
		printData.pageTitle = print.extractDocumentTitle();
		printData.pageOrientation = 'portrait';
		printData.printNote = 'If the table is too wide, try printing in <b>landscape mode</b> or change the <b>scale</b> value.';
		printData.printElement = document.forms[0].parentNode;
		printData.printTemplate = 'print_table.jsp';
		internal.openPrintWindow(printData);
	}
	
	
	/*
		Finalize the table print preview by setting document title, etc.
		Several adjustments are made to the visual appearance of the table to
		make it more suitable for printing.
	*/
	print.finalizeTablePrint = function(printWin)
	{
		var printData = internal.printData;
		
		// Initalize common options
		internal.setDefaultPrintOptions(printWin, printData);
		
		// Get the source element to be printed and the print-area copy
		var printElement = printData.printElement;
		var printArea = printWin.document.getElementById('print-area');
				
		// Remove 'fulltable' since that is absolutely positioned
		Main.removeClass(printArea, 'fulltable');
		
		// Check the filter row if any filter has been set, and copy values
		// since not all are copied when using innerHTML
		var srcInput = printElement.getElementsByTagName('input');
		var printInput = printArea.getElementsByTagName('input');
		var hideFilterRow = true;
		for (var i = 0; i < srcInput.length; i++)
		{
			var src = srcInput[i];
			if (src.name.indexOf('filter:') == 0 || src.name.indexOf('display:') == 0)
			{
				// For now, ignore all radio buttons
				if (src.type != radio)
				{
					var value = src.value;
					if (value != '') 
					{
						hideFilterRow = false;
						printInput[i].value = value;
					}
				}
			}
		}
		
		// Labels and radio buttons are handled separately
		var labels = printArea.getElementsByTagName('label');
		for (var i = 0; i < labels.length; i++)
		{
			// Always hide the actual radio button
			var radio = printWin.document.getElementById(labels[i].getAttribute('for'));
			radio.style.display = 'none';
			if (!radio.checked)
			{
				// and all labels for unchecked buttons
				labels[i].style.display = 'none';
			}
			else
			{
				// Keep only the label for the checked radio button
				hideFilterRow = false;
			}
		}
		
		// Hide the filter row if there are no filters
		if (hideFilterRow) printArea.className += ' nofilterrow';
		
		// Replace the 'check' table column with empty content
		var allCheck = printArea.getElementsByClassName('check');
		for (var i = 0; i < allCheck.length; i++)
		{
			allCheck[i].innerHTML = '';
		}
	}
	
	/*
		Try to extract a document title. If the 'document.title' property is
		set, use that. Otherwise get text from the first '<h1>' tag in the
		document.
	*/
	print.extractDocumentTitle = function()
	{
		var documentTitle = null;
		if (document.title)
		{
			documentTitle = document.title;
		}
		else
		{
			var h1 = document.getElementsByTagName('h1');
			if (h1.length > 0)
			{
				// We found a h1 element, get text-only from child nodes
				var title = [];
				for (var i = 0; i < h1[0].childNodes.length; i++)
				{
					title[title.length] = h1[0].childNodes[i].textContent;
				}
				documentTitle = title.join(', ');
			}
		}
		return documentTitle;
	}
	
	/*
		Internal function for opening the print window. printData is
		an object containing print options.
		
	*/
	internal.openPrintWindow = function(printData)
	{
		// Default width/height is for 'portrait' orientation
		var width = 900;
		var height = 900;
		if (printData.pageOrientation == 'landscape')
		{
			width = 1300;
			height = 700;
		}
		
		internal.printData = printData;

		// Open the print-window 
		var printTemplate = HOME_URL + printData.printTemplate;
		printWin = window.open(printTemplate, 'PrintWindow', 'width='+width+',height='+height+',toolbar=yes,location=no,directories=no,status=no,menubar=yes,scrollbars=yes,resizable=yes');
	}
	
	internal.setDefaultPrintOptions = function(printWin, printData)
	{
		// Set page title...
		if (printData.pageTitle) 
		{
			printWin.document.title = printData.pageTitle;
			printWin.document.getElementById('print-title').innerHTML = printData.pageTitle;
		}
	
		// ...orientation...
		if (printData.pageOrientation)
		{
			var paper = printWin.document.getElementById('paper');
			paper.className += ' ' + printData.pageOrientation;
			var landscape = printWin.document.getElementById('orientation-landscape').checked;
			if (landscape && printData.pageOrientation == 'landscape')
			{
				landscape.checked = true;
			}
		}
		
		// ... and print note
		if (printData.printNote)
		{
			var note = printWin.document.getElementById('print-note');
			note.innerHTML = printData.printNote;
		}
		
		// Get the HTML from the source element
		var printElement = printData.printElement;
		var printHtml = printElement.innerHTML;
	
		// Copy the HTML to the print-area in the print-window
		var printArea = printWin.document.getElementById('print-area');
		printArea.innerHTML = printHtml;
		
		// Copy the class name of the source to the print area
		printArea.className += ' ' + printElement.className;
	}
	
	return print;
}();


